//---------------------------------------------------------------------------
//
// Name:        ScrollTextSampleFrm.cpp
// Author:      emarti
// Created:     26.04.2006 18:03:37
// Description: 
//
//---------------------------------------------------------------------------

#include "ScrollTextSampleFrm.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// ScrollTextSampleFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(ScrollTextSampleFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(ScrollTextSampleFrm::ScrollTextSampleFrmClose)
	EVT_PAINT(ScrollTextSampleFrm::ScrollTextSampleFrmPaint)
	EVT_TIMER(ID_WXTIMER1,ScrollTextSampleFrm::WxTimer1Timer)
END_EVENT_TABLE()
////Event Table End

ScrollTextSampleFrm::ScrollTextSampleFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

ScrollTextSampleFrm::~ScrollTextSampleFrm() {}

void ScrollTextSampleFrm::CreateGUIControls(void)
{
	//Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxScrolledWindow1 = new wxScrolledWindow(this, ID_WXSCROLLEDWINDOW1, wxPoint(0,0), wxSize(415,294), wxVSCROLL | wxHSCROLL);
	WxScrolledWindow1->SetBackgroundColour(wxColour(*wxWHITE));

	wxScrollText1 = new wxScrollText(WxScrolledWindow1, ID_WXSCROLLTEXT1,_T("z z z Z Z Z ... class public private protected wx???? ... Z Z Z z z z..."),35,30,120,20);
	wxScrollText1->Start();
	//wxScrollText1->SetBackgroundColour(wxColour(*wxWHITE));

	wxImage::AddHandler( new wxPNGHandler);
	wxImage imgpng;
	imgpng.LoadFile(_T("scrolltext.png"), wxBITMAP_TYPE_PNG);
	bmp = wxBitmap(imgpng);

	wxSize msize(bmp.GetWidth(),bmp.GetHeight());

	wxScrollText2 = new wxScrollText(WxScrolledWindow1, ID_WXSCROLLTEXT2,_T(""),10,msize.y,msize.x,25);
	wxScrollText2->SetForeground_Colour(wxColour(128,128,128));
	wxScrollText2->SetFont(wxFont(7, wxMODERN, wxSLANT, wxBOLD , FALSE, wxT("Tahoma")));
	wxScrollText2->SetTimer(30);
	wxScrollText2->SetScrollPixel(2);
	wxScrollText2->SetText(_T("One man's constant is another man's variable. Alan Perlis"));
	wxScrollText2->Start();
	
	interrupt = true;
	WxTimer1 = new wxTimer();
	WxTimer1->SetOwner(this, ID_WXTIMER1);
	WxTimer1->Start(2270);

	this->SetSize(20,24,msize.x + 30, msize.y + 50);
	this->SetTitle(wxT("Scroll Text Sample by emarti"));
	this->Center();
	this->SetIcon(wxNullIcon);
	
	////GUI Items Creation End
}

void ScrollTextSampleFrm::ScrollTextSampleFrmClose(wxCloseEvent& event)
{
    Destroy();
}
 

/*
 * ScrollTextSampleFrmPaint
 */
void ScrollTextSampleFrm::ScrollTextSampleFrmPaint(wxPaintEvent& event)
{
	wxPaintDC dc(WxScrolledWindow1);
	dc.DrawBitmap(bmp,0,0,true);
	event.Skip();
}

/*
 * WxTimer1Timer
 */
void ScrollTextSampleFrm::WxTimer1Timer(wxTimerEvent& event)
{	
	if (interrupt)
	{	wxScrollText2->Start(); }
	else
	{	wxScrollText2->Stop();WxTimer1->Stop();	}
	
	interrupt = !interrupt;
	event.Skip();
}
